/**
  ******************************************************************************
  * @file    usart.c
  * @author  kevin_guo
  * @version V1.0.0
  * @date    12-15-2018
  * @brief   This file provides functions to usart
  ******************************************************************************
  * @attention
	* Ӳӣ
  *           PA9  - USART1_RXD      
  *           PA10  - USART2_TXD     
  *           9600 λ8 ֹͣλ1 У    
  ******************************************************************************
  */ 
  
/* Includes ------------------------------------------------------------------*/
#include "stm32f10x.h"	
#include <stm32f10x_conf.h>
#include "usart.h"	

/* extern variables ----------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
#define BUFFER_SIZE		16
/* Private variables ---------------------------------------------------------*/
unsigned char rxbuf[16],rxempty, rxcnt,rxflag,waitflag;
unsigned short int length_val;
unsigned int timeout;
/* Private function prototypes -----------------------------------------------*/
/* Private function ----------------------------------------------------------*/
 
/*******************************************************************************
* Function Name  : USART1_IRQHandler
* Description    : usart interrupt function
* Input          : bound-baud
* Output         : None
* Return         : None
*******************************************************************************/
void USART1_IRQHandler(void)                	//1жϷ
{
	unsigned char Res;

	if(USART_GetITStatus(USART1, USART_IT_RXNE) != RESET)  //ж(յݱ0x0d 0x0aβ)
	{
		if(rxflag==0)
		{
			rxbuf[rxcnt++] = USART_ReceiveData(USART1);//(USART1->DR);	//ȡյ
			if(rxcnt>2)
			{
				if(waitflag==1)
				{
					if((rxbuf[rxcnt-2]=='o')&&(rxbuf[rxcnt-1]=='k'))//ڽվݸʽASCII0mm~2000mm
					{
						waitflag=2;
					}
				}
				else
				{
					if((rxbuf[rxcnt-1]=='m')&&(rxbuf[rxcnt-2]=='m'))//ڽվݸʽASCII0mm~2000mm
					{
						rxflag=1;
					}
				}
			}
			else if(rxcnt>=16)
			{
				rxcnt=0;
			}
		}
		else
		{
			rxempty = USART_ReceiveData(USART1);//(USART1->DR);	//ȡյ
		} 
	} 
} 
/*******************************************************************************
* Function Name  : Send_Data_To_UART1
* Description    : send a char to uart
* Input          : dat
* Output         : None
* Return         : None
*******************************************************************************/
void Send_Data_To_UART1(char dat)
{      
	while((USART1->SR&0X40)==0);//ѭ,ֱ   
    USART1->DR = dat;  
}  
/*******************************************************************************
* Function Name  : uart_init
* Description    : config usart1
* Input          : bound-baud
* Output         : None
* Return         : None
*******************************************************************************/
void Uart_Init(u32 bound)
{
	//GPIO˿
	GPIO_InitTypeDef GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1|RCC_APB2Periph_GPIOA, ENABLE);	//ʹUSART1GPIOAʱ
	USART_DeInit(USART1);  //λ1
	//USART1_TX   PA.9
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9; //PA.9
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;	//
	GPIO_Init(GPIOA, &GPIO_InitStructure); //ʼPA9

	//USART1_RX	  PA.10
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;//
	GPIO_Init(GPIOA, &GPIO_InitStructure);  //ʼPA10

	//Usart1 NVIC 

	NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=3 ;//ռȼ3
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;		//ȼ3
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;			//IRQͨʹ
	NVIC_Init(&NVIC_InitStructure);	//ָĲʼVICĴ

	//USART ʼ

	USART_InitStructure.USART_BaudRate = bound;//һΪ9600;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;//ֳΪ8λݸʽ
	USART_InitStructure.USART_StopBits = USART_StopBits_1;//һֹͣλ
	USART_InitStructure.USART_Parity = USART_Parity_No;//żУλ
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;//Ӳ
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;	//շģʽ

	USART_Init(USART1, &USART_InitStructure); //ʼ
	USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);//ж
	USART_Cmd(USART1, ENABLE);                    //ʹܴ 
}


/************************END OF FILE*************************/
